Index: src/edu/ucsb/nceas/metacat/accesscontrol/XMLAccessAccess.java
===================================================================
--- src/edu/ucsb/nceas/metacat/accesscontrol/XMLAccessAccess.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/accesscontrol/XMLAccessAccess.java	(revision 6744)
@@ -35,11 +35,6 @@
 
 import org.apache.log4j.Logger;
 
-import edu.ucsb.nceas.metacat.AccessionNumber;
-import edu.ucsb.nceas.metacat.AccessionNumberException;
-import edu.ucsb.nceas.metacat.DBUtil;
-import edu.ucsb.nceas.metacat.IdentifierManager;
-import edu.ucsb.nceas.metacat.McdbDocNotFoundException;
 import edu.ucsb.nceas.metacat.database.DBConnection;
 import edu.ucsb.nceas.metacat.database.DBConnectionPool;
 import edu.ucsb.nceas.metacat.shared.AccessException;
@@ -48,21 +43,10 @@
 public class XMLAccessAccess extends BaseAccess {
 	
 	private Logger logMetacat = Logger.getLogger(XMLAccessAccess.class);
-	
-	private static String DOCID = "docid";
-	
-	private static String GUID = "guid";
-
-	private String idAttribute = DOCID;
-	
+			
 	// Constructor
 	public XMLAccessAccess() throws AccessException {}
 	
-	public XMLAccessAccess(boolean useGuid) {
-		if (useGuid) {
-			idAttribute = GUID;
-		}
-	}
 
 	/**
 	 * Get all xml access for a document
@@ -71,11 +55,11 @@
 	 *            the id of the document
 	 * @return an xml access DAO list
 	 */ 
-	public Vector<XMLAccessDAO> getXMLAccessForDoc(String id) throws AccessException {
+	public Vector<XMLAccessDAO> getXMLAccessForDoc(String guid) throws AccessException {
 
 		Vector<XMLAccessDAO> xmlAccessList = new Vector<XMLAccessDAO>();
 		
-		if (id == null) {
+		if (guid == null) {
 			throw new AccessException("XMLAccessAccess.getXMLAccessForDoc - doc id " + 
 					"must be specified when selecting xml_access record");
 		}
@@ -88,13 +72,13 @@
 			conn = DBConnectionPool.getDBConnection("XMLAccessAccess.getXMLAccessForDoc");
     		serialNumber = conn.getCheckOutSerialNumber();
 
-			String sql = "SELECT * FROM xml_access WHERE " + idAttribute + " = ?";
+			String sql = "SELECT * FROM xml_access WHERE guid = ?";
 			pstmt = conn.prepareStatement(sql);
 
-			pstmt.setString(1, id);
+			pstmt.setString(1, guid);
 			
 			String sqlReport = "XMLAccessAccess.getXMLAccessForDoc - SQL: " + sql;
-			sqlReport += " [" + id + "]";
+			sqlReport += " [" + guid + "]";
 			
 			logMetacat.info(sqlReport);
 			
@@ -113,10 +97,10 @@
 			
 		} catch (SQLException sqle) {
 			throw new AccessException("XMLAccessAccess.getXMLAccessForDoc - SQL error when getting access " + 
-					" for id: " + id  + " : "  + sqle.getMessage());
+					" for id: " + guid  + " : "  + sqle.getMessage());
 		} catch (PermOrderException poe) {
 			String errorStr = "XMLAccessAccess.getXMLAccessForDoc - Permission order error when getting " + 
-				"access record for doc id: " + id + " : "  + poe.getMessage();
+				"access record for doc id: " + guid + " : "  + poe.getMessage();
 			logMetacat.error(errorStr);
 			throw new AccessException(errorStr);
 		} finally {
@@ -133,12 +117,12 @@
 	 *            the credentials of the principal in the database
 	 * @return an xml access DAO list
 	 */ 
-	public Vector<XMLAccessDAO> getXMLAccessForPrincipal(String id, String principalName) 
+	public Vector<XMLAccessDAO> getXMLAccessForPrincipal(String guid, String principalName) 
 			throws AccessException {
 
 		Vector<XMLAccessDAO> xmlAccessList = new Vector<XMLAccessDAO>();
 		
-		if (id == null) { 
+		if (guid == null) { 
 			throw new AccessException("XMLAccessAccess.getXMLAccessForPrincipal - doc id " + 
 					"must be specified when selecting xml_access record");
 		}
@@ -155,14 +139,14 @@
 			conn = DBConnectionPool.getDBConnection("XMLAccessAccess.getXMLAccessForPrincipal");
     		serialNumber = conn.getCheckOutSerialNumber();
 			
-			String sql = "SELECT * FROM xml_access WHERE " + idAttribute + " = ? AND principal_name = ?";
+			String sql = "SELECT * FROM xml_access WHERE guid = ? AND principal_name = ?";
 			pstmt = conn.prepareStatement(sql);
 
-			pstmt.setString(1, id);
+			pstmt.setString(1, guid);
 			pstmt.setString(2, principalName);
 			
 			String sqlReport = "XMLAccessAccess.getXMLAccessForPrincipal - SQL: " + sql;
-			sqlReport += " [" + id + "," + principalName + "]";
+			sqlReport += " [" + guid + "," + principalName + "]";
 			
 			logMetacat.info(sqlReport);
 			
@@ -181,10 +165,10 @@
 			
 		} catch (SQLException sqle) {
 			throw new AccessException("XMLAccessAccess.getXMLAccessForPrincipal - SQL error when getting access " + 
-					" for id: " + id + ", principal: " + principalName  + " : "  + sqle.getMessage());
+					" for id: " + guid + ", principal: " + principalName  + " : "  + sqle.getMessage());
 		} catch (PermOrderException poe) {
 			String errorStr = "XMLAccessAccess.getXMLAccessForPrincipal - Permission order error when getting " + 
-				"access record for id: " + id + ", principal: " + principalName + " : "  + poe.getMessage();
+				"access record for id: " + guid + ", principal: " + principalName + " : "  + poe.getMessage();
 			logMetacat.error(errorStr);
 			throw new AccessException(errorStr);
 		} finally {
@@ -195,18 +179,18 @@
 	/**
 	 * Get all xml access for a principal/permType/permOrder for a certain document
 	 * 
-	 * @param id
+	 * @param guid
 	 *            the id of the document
 	 * @param principalName
 	 *            the credentials of the principal in the database
 	 * @return an xml access DAO list
 	 */ 
-	public Vector<XMLAccessDAO> getXMLAccessForPrincipal(String id, String principalName, String permType, String permOrder) 
+	public Vector<XMLAccessDAO> getXMLAccessForPrincipal(String guid, String principalName, String permType, String permOrder) 
 			throws AccessException {
 
 		Vector<XMLAccessDAO> xmlAccessList = new Vector<XMLAccessDAO>();
 		
-		if (id == null) { 
+		if (guid == null) { 
 			throw new AccessException("XMLAccessAccess.getXMLAccessForPrincipal - doc id " + 
 					"must be specified when selecting xml_access record");
 		}
@@ -231,17 +215,17 @@
 			conn = DBConnectionPool.getDBConnection("XMLAccessAccess.getXMLAccessForPrincipal");
     		serialNumber = conn.getCheckOutSerialNumber();
     		
-			String sql = "SELECT * FROM xml_access WHERE " + idAttribute + " = ? AND principal_name = ? " + 
+			String sql = "SELECT * FROM xml_access WHERE guid = ? AND principal_name = ? " + 
 				"AND perm_type = ? AND perm_order = ?";
 			pstmt = conn.prepareStatement(sql);
 
-			pstmt.setString(1, id);
+			pstmt.setString(1, guid);
 			pstmt.setString(2, principalName);
 			pstmt.setString(3, permType);			
 			pstmt.setString(4, permOrder);
 			
 			String sqlReport = "XMLAccessAccess.getXMLAccessForPrincipal - SQL: " + sql;
-			sqlReport += " [" + id + "," + principalName + "," +  permType + "," + permOrder + "]";
+			sqlReport += " [" + guid + "," + principalName + "," +  permType + "," + permOrder + "]";
 			
 			logMetacat.info(sqlReport);
 			
@@ -259,10 +243,10 @@
 			
 		} catch (SQLException sqle) {
 			throw new AccessException("XMLAccessAccess.getXMLAccessForPrincipal - SQL error when getting access " + 
-					" for id: " + id + ", principal: " + principalName  + " : "  + sqle.getMessage());
+					" for id: " + guid + ", principal: " + principalName  + " : "  + sqle.getMessage());
 		} catch (PermOrderException poe) {
 			String errorStr = "XMLAccessAccess.getXMLAccessForPrincipal - Permission order error when getting " + 
-				"access record for id: " + id + ", principal: " + principalName + " : "  + poe.getMessage();
+				"access record for id: " + guid + ", principal: " + principalName + " : "  + poe.getMessage();
 			logMetacat.error(errorStr);
 			throw new AccessException(errorStr);
 		} finally {
@@ -275,7 +259,7 @@
 	 * principal already exists, bitwise OR the permission to the existing
 	 * permission and update.
 	 * 
-	 * @param id
+	 * @param guid
 	 *            document id
 	 * @param principalName
 	 *            principal credentials
@@ -286,30 +270,30 @@
 	 * @param permOrder
 	 *            permission order
 	 */
-	public void addXMLAccess(String id, String principalName, Long permission, String permType, 
+	public void addXMLAccess(String guid, String principalName, Long permission, String permType, 
 			String permOrder, String accessFileId, String subTreeId) throws AccessException, PermOrderException {
 		
-		permOrderConflict(id, permOrder);
+		permOrderConflict(guid, permOrder);
 		
 		Vector<XMLAccessDAO> xmlAccessList = 
-			getXMLAccessForPrincipal(id, principalName, permType, permOrder);
+			getXMLAccessForPrincipal(guid, principalName, permType, permOrder);
 		
 		// if more than one record exists for this principal on this document with the same
 		// access type / access order combination, call cleanup to combine common access and then
 		// re-retrieve the access list.
 		if (xmlAccessList.size() == 0) {
-			insertXMLAccess(id, principalName, permission, permType, permOrder, accessFileId, subTreeId);
+			insertXMLAccess(guid, principalName, permission, permType, permOrder, accessFileId, subTreeId);
 			return;
 		}
 		
 		if (xmlAccessList.size() > 1) {
 			cleanupXMLAccessForPrincipal(xmlAccessList);
-			xmlAccessList = getXMLAccessForPrincipal(id, principalName, permType, permOrder);
+			xmlAccessList = getXMLAccessForPrincipal(guid, principalName, permType, permOrder);
 		}
 		
 		if (xmlAccessList.size() == 0) {
 			throw new AccessException("XMLAccessAccess.addXMLAccess - xml access list is empty when " + 
-				"it shouldn't be for id: " + id + ", prinicpal name: " + principalName + ", perm type " + 
+				"it shouldn't be for id: " + guid + ", prinicpal name: " + principalName + ", perm type " + 
 				permType + ", perm order: " + permOrder);	
 		}
 		
@@ -319,7 +303,7 @@
 		//trying to add, update the access record with the existing permission bitwis OR-ed with our
 		// new permission
 		if ((xmlAccessDAO.getPermission() & permission) != permission) {		
-			updateXMLAccessPermission(id, principalName, xmlAccessDAO.getPermission() | permission);
+			updateXMLAccessPermission(guid, principalName, xmlAccessDAO.getPermission() | permission);
 		}
 	}
 	
@@ -332,14 +316,28 @@
 	 * @param xmlAccessList
 	 *            list of xml access dao objects that hold new access for the document
 	 */
-	public void replaceAccess(String id, List<XMLAccessDAO> xmlAccessList) throws AccessException {
-		deleteXMLAccessForDoc(id);
+	public void replaceAccess(String guid, List<XMLAccessDAO> xmlAccessList) throws AccessException {
+		deleteXMLAccessForDoc(guid);
 		
+		insertAccess(guid, xmlAccessList);
+	}
+	
+	/**
+	 * Set permissions for a given document. This means first removing all access control for the
+	 * document and then adding the given rules.
+	 * 
+	 * @param id
+	 *            document id
+	 * @param xmlAccessList
+	 *            list of xml access dao objects that hold new access for the document
+	 */
+	public void insertAccess(String guid, List<XMLAccessDAO> xmlAccessList) throws AccessException {
+		
 		// if more than one record exists for this principal on this document with the same
 		// access type / access order combination, call cleanup to combine common access and then
 		// re-retrieve the access list.
 		for(XMLAccessDAO xmlAccessDAO : xmlAccessList) {
-			insertXMLAccess(id, xmlAccessDAO.getPrincipalName(), xmlAccessDAO.getPermission(), 
+			insertXMLAccess(guid, xmlAccessDAO.getPrincipalName(), xmlAccessDAO.getPermission(), 
 					xmlAccessDAO.getPermType(), xmlAccessDAO.getPermOrder(), xmlAccessDAO.getAccessFileId(), xmlAccessDAO.getSubTreeId());
 		}
 	}
@@ -360,7 +358,7 @@
 	 * @param permOrder
 	 *            permission order
 	 */
-	private void insertXMLAccess(String id, String principalName, Long permission, String permType,
+	private void insertXMLAccess(String guid, String principalName, Long permission, String permType,
 			String permOrder, String accessFileId, String subTreeId) throws AccessException {
 	    //System.out.println("permission in insertXMLAccess: " + permission);
 	    try
@@ -376,7 +374,7 @@
 	        logMetacat.warn(e.getMessage());
 	    }
 	    
-		if (id == null) {
+		if (guid == null) {
 			throw new AccessException("XMLAccessAccess.insertXMLAccess - id is required when " + 
 					"inserting XML access record");
 		}
@@ -405,50 +403,22 @@
 			serialNumber = conn.getCheckOutSerialNumber();
 			
 			String sql = "INSERT INTO xml_access " +
-				"(docid, guid, principal_name, permission, perm_type, perm_order, accessfileid, subtreeid ) " + 
-				"VALUES (?,?,?,?,?,?,?,?)";
+				"(guid, principal_name, permission, perm_type, perm_order, accessfileid, subtreeid ) " + 
+				"VALUES (?,?,?,?,?,?,?)";
 			pstmt = conn.prepareStatement(sql);
 
-			String guid = null;
-			String docid = null;
-			if (idAttribute.equals(GUID)) {
-				guid = id;
-				try {
-					String localId = IdentifierManager.getInstance().getLocalId(id);
-					// Parse the localId into scope and rev parts, strip off the rev
-		            AccessionNumber acc = new AccessionNumber(localId, "NOACTION");
-		            docid = acc.getDocid();
-				} catch (McdbDocNotFoundException e) {
-					//ignore
-					logMetacat.warn("No local id mapping found for guid: " + id);
-				} catch (NumberFormatException e) {
-                    logMetacat.warn("LocalId could not be parsed for guid: " + id);
-                } catch (AccessionNumberException e) {
-                    logMetacat.warn("LocalId could not be parsed for guid: " + id);
-                }
-			} else {
-				int rev = DBUtil.getLatestRevisionInDocumentTable(id);
-				try {
-					guid = IdentifierManager.getInstance().getGUID(id, rev);
-				} catch (McdbDocNotFoundException e) {
-					//ignore
-					logMetacat.warn("No guid mapping found for docid: " + id + "." + rev);
-				}
-				docid = id;
-			}
 			
 			// Bind the values to the query
-			pstmt.setString(1, docid);
-			pstmt.setString(2, guid);
-			pstmt.setString(3, principalName);
-			pstmt.setLong(4, permission);
-			pstmt.setString(5, permType);
-			pstmt.setString(6, permOrder);
-			pstmt.setString(7, accessFileId);
-			pstmt.setString(8, subTreeId);
+			pstmt.setString(1, guid);
+			pstmt.setString(2, principalName);
+			pstmt.setLong(3, permission);
+			pstmt.setString(4, permType);
+			pstmt.setString(5, permOrder);
+			pstmt.setString(6, accessFileId);
+			pstmt.setString(7, subTreeId);
 			
 			String sqlReport = "XMLAccessAccess.insertXMLAccess - SQL: " + sql;
-			sqlReport += " [" + docid + "," + guid + "," + principalName + "," +  permission + "," +  permType + "," + permOrder + "]";
+			sqlReport += " [" + guid + "," + principalName + "," +  permission + "," +  permType + "," + permOrder + "]";
 			
 			logMetacat.info(sqlReport);
 
@@ -455,7 +425,7 @@
 			pstmt.execute();
 		} catch (SQLException sqle) {
 			throw new AccessException("XMLAccessAccess.insertXMLAccess - SQL error when inserting"
-					+ "xml access permissions for id: " + id + ", principal: " + 
+					+ "xml access permissions for id: " + guid + ", principal: " + 
 					principalName + ":" + sqle.getMessage());
 		} finally {
 			closeDBObjects(pstmt, conn, serialNumber, logMetacat); 
@@ -466,7 +436,7 @@
 	 * Update existing xml access permissions in the db.  The permission value should be the combined
 	 * value of pre-existing permissions plus new permissions.
 	 * 
-	 * @param id
+	 * @param guid
 	 *            document id
 	 * @param principalName
 	 *            principal credentials
@@ -473,9 +443,9 @@
 	 * @param permission
 	 *            permission bitmap
 	 */
-	private void updateXMLAccessPermission(String id, String principalName, Long permission)
+	private void updateXMLAccessPermission(String guid, String principalName, Long permission)
 			throws AccessException {
-		if (id == null) {
+		if (guid == null) {
 			throw new AccessException("XMLAccessAccess.updateXMLAccessPermission - id is required when " + 
 					"updating XML access record");
 		}
@@ -497,16 +467,16 @@
 			serialNumber = conn.getCheckOutSerialNumber();
 			
 			String sql = "UPDATE xml_access SET permission = ?" +
-				"WHERE " + idAttribute + " = ? AND principal_name = ?";
+				"WHERE guid = ? AND principal_name = ?";
 			pstmt = conn.prepareStatement(sql);
 
 			// Bind the values to the query
 			pstmt.setLong(1, permission);
-			pstmt.setString(2, id);
+			pstmt.setString(2, guid);
 			pstmt.setString(3, principalName);
 			
 			String sqlReport = "XMLAccessAccess.updateXMLAccessPermission - SQL: " + sql;
-			sqlReport += " [" + permission + "," + id + "," + principalName + "]";
+			sqlReport += " [" + permission + "," + guid + "," + principalName + "]";
 			
 			logMetacat.info(sqlReport);
 
@@ -513,7 +483,7 @@
 			pstmt.execute();
 		} catch (SQLException sqle) {
 			throw new AccessException("XMLAccessAccess.updateXMLAccessPermission - SQL error when updating"
-					+ "xml access permissions for id: " + id + ", principal: " + 
+					+ "xml access permissions for id: " + guid + ", principal: " + 
 					principalName + ":" + sqle.getMessage());
 		} finally {
 			closeDBObjects(pstmt, conn, serialNumber, logMetacat); 
@@ -526,13 +496,13 @@
 	 * for a given document.  If the provided permission is exactly the same as what 
 	 * the principal has, the record is deleted from the database.
 	 * 
-	 * @param id
+	 * @param guid
 	 *            document id
 	 * @param principalName
 	 *            principal credentials
 	 */
-	public void removeXMLAccessForPrincipal(String id, String principalName, Long permission) throws AccessException {
-		if (id == null) {
+	public void removeXMLAccessForPrincipal(String guid, String principalName, Long permission) throws AccessException {
+		if (guid == null) {
 			throw new AccessException("XMLAccessAccess.removeXMLAccessForPrincipal - id is required when " + 
 					"removing XML access");
 		}
@@ -545,10 +515,10 @@
 					"updating XML access");
 		}
 		
-		Vector<XMLAccessDAO> xmlAccessList = getXMLAccessForPrincipal(id, principalName);
+		Vector<XMLAccessDAO> xmlAccessList = getXMLAccessForPrincipal(guid, principalName);
 		if (xmlAccessList.size() == 0) {
 			logMetacat.warn("XMLAccessAccess.removeXMLAccessForPrincipal - attempting to remove access when no " +
-				"access record exists for id: " + id + ", principal: " + principalName);
+				"access record exists for id: " + guid + ", principal: " + principalName);
 		} else {
 			long permissionMask = 0;
 			for (XMLAccessDAO xmlAccessDAO : xmlAccessList) {
@@ -559,13 +529,13 @@
 			// in this case, the only existing permissions are the ones we want to remove, so 
 			// delete the record(s) for this principal on this document
 			if ((permissionMask & permission) == permission) {
-				deleteXMLAccessForPrincipal(id, principalName);
+				deleteXMLAccessForPrincipal(guid, principalName);
 			}
 			
 			if (xmlAccessList.size() > 1) {
 				
 			} else {
-				updateXMLAccessPermission(id, principalName, permission);
+				updateXMLAccessPermission(guid, principalName, permission);
 			}
 		}
 	   
@@ -577,8 +547,8 @@
 	 * @param id
 	 *            document id
 	 */
-	public void deleteXMLAccessForDoc(String id) throws AccessException {
-		if (id == null) {
+	public void deleteXMLAccessForDoc(String guid) throws AccessException {
+		if (guid == null) {
 			throw new AccessException("XMLAccessAccess.deleteXMLAccessForPrincipal - id is required when " + 
 					"deleting XML access record");
 		}
@@ -588,48 +558,18 @@
 		int serialNumber = -1;
 		try {
 			
-			String guid = null;
-			String docid = null;
-			if (idAttribute.equals(GUID)) {
-				guid = id;
-				try {
-					String localId = IdentifierManager.getInstance().getLocalId(id);
-					// Parse the localId into scope and rev parts, strip off the rev
-		            AccessionNumber acc = new AccessionNumber(localId, "NOACTION");
-		            docid = acc.getDocid();
-				} catch (McdbDocNotFoundException e) {
-					//ignore
-					logMetacat.warn("No local id mapping found for guid: " + id);
-				} catch (NumberFormatException e) {
-                    logMetacat.warn("LocalId could not be parsed for guid: " + id);
-                } catch (AccessionNumberException e) {
-                    logMetacat.warn("LocalId could not be parsed for guid: " + id);
-                }
-			} else {
-				int rev = DBUtil.getLatestRevisionInDocumentTable(id);
-				try {
-					guid = IdentifierManager.getInstance().getGUID(id, rev);
-				} catch (McdbDocNotFoundException e) {
-					//ignore
-					logMetacat.warn("No guid mapping found for docid: " + id + "." + rev);
-				}
-				docid = id;
-			}
-			
 			// check out DBConnection
 			conn = DBConnectionPool.getDBConnection("XMLAccessAccess.deleteXMLAccessForDoc");
     		serialNumber = conn.getCheckOutSerialNumber();
     		
-			String sql = "DELETE FROM xml_access WHERE docid = ? OR guid = ?";
+			String sql = "DELETE FROM xml_access WHERE guid = ?";
 			pstmt = conn.prepareStatement(sql);
 
 			// Bind the values to the query
-			pstmt.setString(1, docid);
-			pstmt.setString(2, guid);
+			pstmt.setString(1, guid);
 
-
 			String sqlReport = "XMLAccessAccess.deleteXMLAccessForDoc - SQL: " + sql;
-			sqlReport += " [" + id + "]";
+			sqlReport += " [" + guid + "]";
 			
 			logMetacat.info(sqlReport);
 
@@ -636,7 +576,7 @@
 			pstmt.execute();
 		} catch (SQLException sqle) {
 			throw new AccessException("XMLAccessAccess.deleteXMLAccessForDoc - SQL error when deleting"
-					+ "xml access permissions for id: " + id + ":" + sqle.getMessage());
+					+ "xml access permissions for id: " + guid + ":" + sqle.getMessage());
 		} finally {
 			closeDBObjects(pstmt, conn, serialNumber, logMetacat); 
 		}	   
@@ -646,13 +586,13 @@
 	 * Delete xml access.  This removes all access records from the database for a principal 
 	 * for a given document
 	 * 
-	 * @param id
+	 * @param guid
 	 *            document id
 	 * @param principal
 	 *            principal credentials
 	 */
-	private void deleteXMLAccessForPrincipal(String id, String principalName) throws AccessException {
-		if (id == null) {
+	private void deleteXMLAccessForPrincipal(String guid, String principalName) throws AccessException {
+		if (guid == null) {
 			throw new AccessException("XMLAccessAccess.deleteXMLAccessForPrincipal - id is required when " + 
 					"deleting XML access record");
 		}
@@ -669,15 +609,15 @@
 			conn = DBConnectionPool.getDBConnection("XMLAccessAccess.deleteXMLAccessForPrincipal");
     		serialNumber = conn.getCheckOutSerialNumber();
     		
-			String sql = "DELETE FROM xml_access WHERE " + idAttribute + " = ? AND principal_name = ?";
+			String sql = "DELETE FROM xml_access WHERE guid = ? AND principal_name = ?";
 			pstmt = conn.prepareStatement(sql);
 
 			// Bind the values to the query
-			pstmt.setString(1, id);
+			pstmt.setString(1, guid);
 			pstmt.setString(2, principalName);
 
 			String sqlReport = "XMLAccessAccess.deleteXMLAccessForPrincipal - SQL: " + sql;
-			sqlReport += " [" + id + "," + principalName + "]";
+			sqlReport += " [" + guid + "," + principalName + "]";
 			
 			logMetacat.info(sqlReport);
 
@@ -684,7 +624,7 @@
 			pstmt.execute();
 		} catch (SQLException sqle) {
 			throw new AccessException("XMLAccessAccess.deleteXMLAccessForPrincipal - SQL error when deleting"
-					+ "xml access permissions for id: " + id + ", principal: " + 
+					+ "xml access permissions for id: " + guid + ", principal: " + 
 					principalName + ":" + sqle.getMessage());
 		} finally {
 			closeDBObjects(pstmt, conn, serialNumber, logMetacat);
@@ -692,16 +632,65 @@
 	}
 	
 	/**
+	 * Delete xml access.  This removes all access records from the database for a principal 
+	 * for a given document
+	 * 
+	 * @param guid
+	 *            document id
+	 * @param principal
+	 *            principal credentials
+	 */
+	public void deleteXMLAccessForDoc(String guid, String permType) throws AccessException {
+		if (guid == null) {
+			throw new AccessException("XMLAccessAccess.deleteXMLAccessForDoc - id is required when " + 
+					"deleting XML access record");
+		}
+		if (permType == null) {
+			throw new AccessException("XMLAccessAccess.deleteXMLAccessForDoc - permType is required when " + 
+					"deleting XML access record");
+		}
+		
+	    PreparedStatement pstmt = null;
+		DBConnection conn = null;
+		int serialNumber = -1;
+		try {
+			// check out DBConnection
+			conn = DBConnectionPool.getDBConnection("XMLAccessAccess.deleteXMLAccessForDoc");
+    		serialNumber = conn.getCheckOutSerialNumber();
+    		
+			String sql = "DELETE FROM xml_access WHERE guid = ? AND perm_type = ?";
+			pstmt = conn.prepareStatement(sql);
+
+			// Bind the values to the query
+			pstmt.setString(1, guid);
+			pstmt.setString(2, permType);
+
+			String sqlReport = "XMLAccessAccess.deleteXMLAccessForDoc - SQL: " + sql;
+			sqlReport += " [" + guid + "," + permType + "]";
+			
+			logMetacat.info(sqlReport);
+
+			pstmt.execute();
+		} catch (SQLException sqle) {
+			throw new AccessException("XMLAccessAccess.deleteXMLAccessForDoc - SQL error when deleting"
+					+ "xml access permissions for id: " + guid + ", permType: " + 
+					permType + ":" + sqle.getMessage());
+		} finally {
+			closeDBObjects(pstmt, conn, serialNumber, logMetacat);
+		}	   
+	}
+	
+	/**
 	 * Checks to see if there is a permission order conflict for a given document.  Each 
 	 * document is only allowed to have a single permission order
 	 * 
-	 * @param id
+	 * @param guid
 	 *            document id
 	 * @param principal
 	 *            principal credentials
 	 */
-	private void permOrderConflict(String id, String permOrder) throws AccessException, PermOrderException {
-		if (id == null) {
+	private void permOrderConflict(String guid, String permOrder) throws AccessException, PermOrderException {
+		if (guid == null) {
 			throw new AccessException("XMLAccessAccess.permOrderConflict - id is required when " + 
 					"determining perm order conflict");
 		}
@@ -718,15 +707,15 @@
 			conn = DBConnectionPool.getDBConnection("XMLAccessAccess.permOrderConflict");
     		serialNumber = conn.getCheckOutSerialNumber();
     		
-			String sql = "SELECT * FROM xml_access WHERE " + idAttribute + " = ? AND perm_order != ?";
+			String sql = "SELECT * FROM xml_access WHERE guid = ? AND perm_order != ?";
 			pstmt = conn.prepareStatement(sql);
 
 			// Bind the values to the query
-			pstmt.setString(1, id);
+			pstmt.setString(1, guid);
 			pstmt.setString(2, permOrder);
 			
 			String sqlReport = "XMLAccessAccess.permOrderConflict - SQL: " + sql;
-			sqlReport += " [" + id + "," + permOrder + "]";
+			sqlReport += " [" + guid + "," + permOrder + "]";
 			
 			logMetacat.info(sqlReport);
 
@@ -735,11 +724,11 @@
 			ResultSet resultSet = pstmt.getResultSet();
 			if (resultSet.next()) {			
 				throw new PermOrderException("XMLAccessAccess.addXMLAccess - cannot add permission " + 
-					"record for id: " + id + "with permOrder: " + permOrder + " due to permOrder conflict");
+					"record for id: " + guid + "with permOrder: " + permOrder + " due to permOrder conflict");
 			}
 		} catch (SQLException sqle) {
 			throw new AccessException("XMLAccessAccess.permOrderConflict - SQL error when checking"
-					+ "for perm order conflict on: " + id + ":" + sqle.getMessage());
+					+ "for perm order conflict on: " + guid + ":" + sqle.getMessage());
 		} finally {
 			closeDBObjects(pstmt, conn, serialNumber, logMetacat); 
 		}
@@ -750,13 +739,13 @@
 	 * Delete xml access.  This removes all access records from the database for a principal 
 	 * for a given document, perm type and perm order
 	 * 
-	 * @param id
+	 * @param guid
 	 *            document id
 	 * @param principal
 	 *            principal credentials
 	 */
-	private void deleteXMLAccessForPrincipal(String id, String principalName, String permType, String permOrder) throws AccessException {
-		if (id == null) {
+	private void deleteXMLAccessForPrincipal(String guid, String principalName, String permType, String permOrder) throws AccessException {
+		if (guid == null) {
 			throw new AccessException("XMLAccessAccess.deleteXMLAccessForPrincipal - id is required when " + 
 					"deleting XML access record");
 		}
@@ -783,18 +772,18 @@
 			conn = DBConnectionPool.getDBConnection("XMLAccessAccess.deleteXMLAccessForPrincipal");
     		serialNumber = conn.getCheckOutSerialNumber();
     		
-			String sql = "DELETE FROM xml_access WHERE " + idAttribute + " = ? AND principal_name = ? " +
+			String sql = "DELETE FROM xml_access WHERE guid = ? AND principal_name = ? " +
 				"AND perm_type = ? AND perm_order = ?";
 			pstmt = conn.prepareStatement(sql);
 
 			// Bind the values to the query
-			pstmt.setString(1, id);
+			pstmt.setString(1, guid);
 			pstmt.setString(2, principalName);
 			pstmt.setString(3, permType);
 			pstmt.setString(4, permOrder);
 			
 			String sqlReport = "XMLAccessAccess.deleteXMLAccessForPrincipal - SQL: " + sql;
-			sqlReport += " [" + id + "," + principalName + "," + permType + "," + permOrder + "]";
+			sqlReport += " [" + guid + "," + principalName + "," + permType + "," + permOrder + "]";
 			
 			logMetacat.info(sqlReport);
 
@@ -801,7 +790,7 @@
 			pstmt.execute();
 		} catch (SQLException sqle) {
 			throw new AccessException("XMLAccessAccess.deleteXMLAccessForPrincipal - SQL error when deleting"
-					+ "xml access permissions for id: " + id + ", principal: " + 
+					+ "xml access permissions for id: " + guid + ", principal: " + 
 					principalName + ":" + sqle.getMessage());
 		} finally {
 			closeDBObjects(pstmt, conn, serialNumber, logMetacat); 
@@ -822,7 +811,7 @@
 		int numDenyRecords = 0;
 		long allowPermissionMask = 0;
 		long denyPermissionMask = 0;
-		String id = null;
+		String guid = null;
 		String principalName = null;
 		String permType = null;
 		String permOrder = null;
@@ -834,16 +823,13 @@
 		// iterate through the list of access dao objects and bttwise or the permissions.  Most
 		// of this is just doing some error checking to make sure each record is valid.
 		for (XMLAccessDAO xmlAccessDAO : xmlAccessList) {
-			String daoId = xmlAccessDAO.getDocId();
-			if (idAttribute.equals(GUID)) {
-				daoId = xmlAccessDAO.getGuid();
-			}
-			if (id == null) {
-				id = daoId;
+			String daoId = xmlAccessDAO.getGuid();
+			if (guid == null) {
+				guid = daoId;
 			} else {
-				if (!id.equals(daoId)) {
+				if (!guid.equals(daoId)) {
 					throw new AccessException("XMLAccessAccess.cleanupXMLAccessForPrincipal - " + 
-							" Conflicting ids " + daoId + " and " + id);
+							" Conflicting ids " + daoId + " and " + guid);
 				}
 			}
 			if (principalName == null) {
@@ -900,14 +886,14 @@
 		// if there was more than one allow record, remove all allow records for this user on this doc 
 		// with this perm type and perm order then insert a single record 
 		if (numAllowRecords > 1) {
-			deleteXMLAccessForPrincipal(id, principalName, AccessControlInterface.ALLOW, permOrder);
-			insertXMLAccess(id, principalName, allowPermissionMask, AccessControlInterface.ALLOW, permOrder, accessFileId, subTreeId);
+			deleteXMLAccessForPrincipal(guid, principalName, AccessControlInterface.ALLOW, permOrder);
+			insertXMLAccess(guid, principalName, allowPermissionMask, AccessControlInterface.ALLOW, permOrder, accessFileId, subTreeId);
 		}
 		// if there was more than one deny record, remove all deny records for this user on this doc 
 		// with this perm type and perm order then insert a single record 
 		if (numDenyRecords > 1) {
-			deleteXMLAccessForPrincipal(id, principalName, AccessControlInterface.DENY, permOrder);
-			insertXMLAccess(id, principalName, denyPermissionMask, AccessControlInterface.DENY, permOrder, accessFileId, subTreeId);
+			deleteXMLAccessForPrincipal(guid, principalName, AccessControlInterface.DENY, permOrder);
+			insertXMLAccess(guid, principalName, denyPermissionMask, AccessControlInterface.DENY, permOrder, accessFileId, subTreeId);
 		}
 	}
 	
